package com.dapr.service.controller;

import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Mono;

import java.io.*;
import java.util.Map;

@RestController
public class SaveController extends CommonController {

    @PostMapping(path = "/save")
    public Mono<String> handleMethod(@RequestBody(required = false) byte[] body,
                                     @RequestHeader Map<String, String> headers) {
        return Mono.fromSupplier(() -> {
            try {
                // bodyTmpl="{\"content\": \"%s\"}}";
                String message = setBody(body, headers);
                save(message);
                return message + " received";
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        });
    }

    /**
     * 新增信息
     * @param body
     * @throws IOException
     */
    private void save(String body) throws IOException {

        // 提取参数
        JSONObject jsonObject = JSONObject.parseObject(body);
        String content = jsonObject.getString("content");
        System.out.println("Content: " + content);

        //拼接SQL
        String bodyTmpl = "{\"operation\": \"exec\",\"metadata\": {\"sql\": \"INSERT INTO feedback (content) VALUES (\\\"%s\\\")\" }}";
        String sql =String.format(bodyTmpl,content);

        // 请求mysql
    //    doMysqlPost(sql);

        // 请求MQ
        sendExecMsg(sql);
    }
}